SystemOrganization addCategory: #'ShoutCore-Monticello'!
SystemOrganization addCategory: #'ShoutCore-Parsing'!
SystemOrganization addCategory: #'ShoutCore-Styling'!
(PackageInfo named: 'ShoutCore') postscript: 'SHTextStylerST80 syntaxHighlightingAsYouType: Preferences syntaxHighlightingAsYouType.
SHTextStylerST80 syntaxHighlightingAsYouTypeLeftArrowAssignment: Preferences syntaxHighlightingAsYouTypeLeftArrowAssignment.
SHTextStylerST80 syntaxHighlightingAsYouTypeAnsiAssignment: Preferences syntaxHighlightingAsYouTypeAnsiAssignment.'!

Object subclass: #SHMCClassDefinition
	instanceVariableNames: 'classDefinition items meta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoutCore-Monticello'!

!SHMCClassDefinition class methodsFor: 'as yet unclassified' stamp: 'tween 5/1/2004 12:27'!
classDefinition: aMCClassDefinition items: anObject meta: aBoolean
	^self new
		classDefinition: aMCClassDefinition;
		items: anObject;
		meta: aBoolean;
		yourself! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'tween 5/1/2004 12:35'!
allInstVarNames
	| superclassOrDef answer classOrDef instVars|
	
	answer := meta
		ifTrue:[classDefinition classInstVarNames asArray]
		ifFalse:[	classDefinition instVarNames asArray].
	classOrDef := classDefinition.
	[superclassOrDef := (classOrDef isKindOf: MCClassDefinition)
		ifTrue:[ |s|
			s := classOrDef superclassName.
			items 
				detect: [:ea | ea isClassDefinition and: [ea className = s]]
				ifNone: [Smalltalk at: s asSymbol ifAbsent:[nil]]]
		ifFalse:[ | sc |
			sc := classOrDef superclass.
			sc ifNotNil:[
				items 
					detect: [:ea | ea isClassDefinition and: [ea className = sc name asString]]
					ifNone: [sc]	]].
	superclassOrDef isNil
	] whileFalse:[
		instVars := (superclassOrDef isKindOf: MCClassDefinition)
			ifTrue:[
				meta 
					ifTrue:[superclassOrDef classInstVarNames]
					ifFalse:[superclassOrDef instVarNames]]
			ifFalse:["real"
				meta
					ifTrue:[superclassOrDef theNonMetaClass class  instVarNames]
					ifFalse:[superclassOrDef theNonMetaClass instVarNames]].		
		answer := answer, instVars.
		classOrDef := superclassOrDef].
	^answer! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'ul 4/29/2010 12:34'!
allowUnderscoreAssignments

	^nil! !

!SHMCClassDefinition methodsFor: 'act like environment' stamp: 'tween 5/9/2004 12:27'!
bindingOf: aSymbol
	| binding |
	(binding := Smalltalk bindingOf: aSymbol)
		ifNotNil: [^binding].
	items do:[:each |
		(each isClassDefinition and: [each className = aSymbol])
			ifTrue:[^aSymbol -> each]].
	^nil! !

!SHMCClassDefinition methodsFor: 'accessing' stamp: 'tween 5/1/2004 11:38'!
classDefinition: aMCClassDefinition
	classDefinition := aMCClassDefinition! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'tween 5/1/2004 12:17'!
classPool
	| d |
	d := Dictionary new.
	classDefinition classVarNames do:[:each |
		d at: each put: nil].
	^d! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'tween 5/9/2004 12:21'!
environment
	^self! !

!SHMCClassDefinition methodsFor: 'act like environment' stamp: 'ar 3/5/2010 20:38'!
hasBindingThatBeginsWith: aString

	(Smalltalk globals hasBindingThatBeginsWith: aString) ifTrue: [^true].
	items do:[:each |
		(each isClassDefinition and: [each className beginsWith: aString])
			ifTrue:[^true]].
	^false! !

!SHMCClassDefinition methodsFor: 'accessing' stamp: 'tween 5/1/2004 11:37'!
items: anObject
	items := anObject! !

!SHMCClassDefinition methodsFor: 'accessing' stamp: 'tween 5/1/2004 12:26'!
meta: aBoolean
	meta := aBoolean! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'ul 7/9/2015 20:59'!
sharedPools
	| d |
	d := Set new.
	classDefinition poolDictionaries do:[:each |
		d add: (Smalltalk at: each asSymbol ifAbsent:[nil]) ].
	^d! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'kb 2/26/2010 14:38'!
shoutParserClass
	"Answer the parser class"
	^SHParserST80! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'tween 5/1/2004 12:28'!
theNonMetaClass
	^self copy meta: false; yourself! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'ul 5/2/2015 13:36'!
withAllSuperclasses

	| result |
	result := OrderedCollection new.
	self withAllSuperclassesDo: [ :each | result addFirst: each ].
	^result! !

!SHMCClassDefinition methodsFor: 'act like a class' stamp: 'ul 5/2/2015 13:32'!
withAllSuperclassesDo: aBlock

	| superclassOrDef classOrDef |
	aBlock value: self.
	classOrDef := classDefinition.
	[ 
		superclassOrDef := (classOrDef isKindOf: MCClassDefinition)
			ifTrue: [
				| superclassName |
				superclassName := classOrDef superclassName.
				items 
					detect: [ :each | 
						each isClassDefinition and: [
							each className = superclassName ] ]
					ifNone: [ Smalltalk classNamed: superclassName ] ]
			ifFalse: [ 
				classOrDef superclass ifNotNil: [ :superclass |
					| superclassName |
					superclassName := superclass name asString.
					items 
						detect: [ :each | 
							each isClassDefinition and: [
								each className = superclassName ] ]
						ifNone: [ superclass ] ] ].
		superclassOrDef isNil ] 
		whileFalse: [
			aBlock value: superclassOrDef.
			classOrDef := superclassOrDef ]! !

Object subclass: #SHParserST80
	instanceVariableNames: 'classOrMetaClass source workspace arguments sourcePosition currentToken currentTokenFirst temporaries instanceVariables errorBlock currentTokenSourcePosition blockDepth bracketDepth ranges environment allowUnderscoreAssignments allowUnderscoreSelectors parseAMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoutCore-Parsing'!

!SHParserST80 commentStamp: 'tween 8/16/2004 15:44' prior: 0!
I am a Smalltalk method / expression parser.

Rather than creating an Abstract Syntax Tree, I create a sequence of SHRanges (in my 'ranges' instance variable), which represent the tokens within the String I am parsing.

I am used by a SHTextStylerST80 to parse method source strings.
I am able to parse incomplete / incorrect methods, and so can be used to parse methods that are being edited.

My 'source' instance variable should be set to the string to be parsed.

My 'classOrMetaClass' instance var must be set to the class or metaClass for the method source so that I can correctly resolve identifiers within the source. If this is nil , I parse the source as an expression (i.e. a doIt expression).

My 'workspace' instance variable can be set to a Workspace, so that I can resolve workspace variables.

My 'environment' instance variable is the global namespace (this is initialized to Smalltalk, but can be set to a different environment).

Example 1.
	ranges := SHParserST80 new
		classOrMetaClass: Object;
		source: 'testMethod ^self';
		parse;
		ranges
		
!

!SHParserST80 class methodsFor: 'instance creation' stamp: 'tween 5/9/2004 12:44'!
new
	^super new
		initialize;
		yourself! !

!SHParserST80 methodsFor: 'accessing' stamp: 'tween 4/13/2004 20:20'!
classOrMetaClass: aClass
    classOrMetaClass := aClass! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 2/10/2014 17:14'!
currentChar
	^source at: sourcePosition ifAbsent: nil! !

!SHParserST80 methodsFor: 'parse support' stamp: 'tween 4/28/2004 09:48'!
enterBlock
	blockDepth := blockDepth + 1.
	bracketDepth := bracketDepth + 1! !

!SHParserST80 methodsFor: 'accessing' stamp: 'tween 5/9/2004 12:43'!
environment: anObject
	environment := anObject! !

!SHParserST80 methodsFor: 'error handling' stamp: 'tween 4/28/2004 10:16'!
error
	self 
		rangeType: #excessCode
		start: (ranges isEmpty ifTrue: [1] ifFalse: [ranges last end + 1])
		end: source size.
	errorBlock value! !

!SHParserST80 methodsFor: 'error handling' stamp: 'tween 8/7/2005 14:31'!
failUnless: aBoolean
	aBoolean ifFalse:[self error]
! !

!SHParserST80 methodsFor: 'error handling' stamp: 'tween 8/7/2005 14:31'!
failWhen: aBoolean
	aBoolean ifTrue:[self error]! !

!SHParserST80 methodsFor: 'accessing' stamp: 'ar 3/5/2010 22:03'!
initialize
	environment := Smalltalk globals.! !

!SHParserST80 methodsFor: 'parse support' stamp: 'ul 4/26/2015 17:57'!
initializeInstanceVariables

	instanceVariables := classOrMetaClass 
		ifNil: [ #() ]
		ifNotNil: [ classOrMetaClass allInstVarNames asArray ]! !

!SHParserST80 methodsFor: 'token testing' stamp: 'tween 4/28/2004 09:43'!
isAnsiAssignment
	^currentToken = ':='! !

!SHParserST80 methodsFor: 'token testing' stamp: 'ul 4/26/2015 20:10'!
isAssignment

	self isAnsiAssignment ifTrue: [ ^true ].
	^allowUnderscoreAssignments and: [ currentToken = '_' ]! !

!SHParserST80 methodsFor: 'character testing' stamp: 'kwl 7/4/2006 06:54'!
isBigDigit: aCharacter base: anInteger
    "Answer true if aCharacter is a digit or a capital
    letter appropriate for base anInteger"
	| digitValue |
	
	digitValue := aCharacter digitValue.
	^digitValue >= 0 and:[digitValue < anInteger]! !

!SHParserST80 methodsFor: 'token testing' stamp: 'ul 4/26/2015 19:58'!
isBinary

	currentToken ifNil: [ ^false ].
	self isName ifTrue: [ ^false ].
	self isKeyword ifTrue: [ ^false ].
	1 to: currentToken size do: [ :i |
		(self isSelectorCharacter: (currentToken at: i)) ifFalse: [ ^false ] ].
	^true! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'tween 5/7/2004 06:24'!
isBlockArgName: aString 
	"Answer true if aString is the name of a block argument, false otherwise"
	| temp arg |
	blockDepth to: 1 by: -1 do: [:level | 
		arg := (arguments at: level ifAbsent: [#()]) includes: aString.
		arg ifTrue: [^true].
		temp := (temporaries at: level ifAbsent: [#()]) includes: aString.
		temp ifTrue: [^false]].
	^false! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'tween 5/7/2004 06:24'!
isBlockTempName: aString 
	"Answer true if aString is the name of a block temporary. false otherwise"

	| temp arg |
	blockDepth to: 1 by: -1 do: [:level | 
		arg := (arguments at: level ifAbsent: [#()]) includes: aString.
		arg ifTrue: [^false].
		temp := (temporaries at: level ifAbsent: [#()]) includes: aString.
		temp ifTrue: [^true]].
	^false! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'tween 5/7/2004 06:37'!
isIncompleteBlockArgName: aString 
	"Answer true if aString is the start of the name of a block argument, false otherwise"
	|  arg |
	blockDepth to: 1 by: -1 do: [:level | 
		arg := (arguments at: level ifAbsent: [#()]) anySatisfy: [:each | each beginsWith: aString].
		arg ifTrue: [^true]].
	^false! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'tween 5/7/2004 06:37'!
isIncompleteBlockTempName: aString 
	"Answer true if aString is the start of the name of a block temporary. false otherwise"

	| temp  |
	blockDepth to: 1 by: -1 do: [:level | 
		temp := (temporaries at: level ifAbsent: [#()]) anySatisfy: [:each | each beginsWith: aString].
		temp ifTrue: [^true]].
	^false! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'tween 5/7/2004 06:38'!
isIncompleteMethodArgName: aString 
	"Answer true if aString is the start of the name of a method argument, false otherwise.
    Does not check whether aString is also a blockArgName"

	^(arguments at: 0 ifAbsent: [#()]) anySatisfy: [:each | each beginsWith: aString]! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'tween 5/7/2004 06:39'!
isIncompleteMethodTempName: aString 
	"Answer true if aString is the start of then name of a method temporary, false otherwise."

	^(temporaries at: 0 ifAbsent: [#()]) anySatisfy: [:each | each beginsWith: aString]! !

!SHParserST80 methodsFor: 'token testing' stamp: 'ul 5/1/2015 13:42'!
isKeyword
	"This method assumes that currentTokenFirst is a non-letter character when currentToken is nil."

	currentTokenFirst isLetter ifTrue: [
		^currentToken last == $: ].
	^allowUnderscoreSelectors
		and: [ currentTokenFirst == $_ 
		and: [ currentToken notNil
		and: [ currentToken size > 1
		and: [ currentToken last == $: ] ] ] ]! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'tween 5/7/2004 06:26'!
isMethodArgName: aString 
	"Answer true if aString is the name of a method argument, false otherwise.
    Does not check whether aString is also a blockArgName"

	^(arguments at: 0 ifAbsent: [#()]) includes: aString! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'tween 5/7/2004 06:25'!
isMethodTempName: aString 
	"Answer true if aString is the name of a method temporary, false otherwise.
    Does not check whether aString is also a block temporary
    or argument"

	((arguments at: 0 ifAbsent: [#()]) includes: aString) ifTrue: [^false].
	^(temporaries at: 0 ifAbsent: [#()]) includes: aString! !

!SHParserST80 methodsFor: 'token testing' stamp: 'ul 5/1/2015 13:42'!
isName
	"This method assumes that currentTokenFirst is a non-letter character when currentToken is nil."

	^(currentTokenFirst isLetter
		or: [ allowUnderscoreSelectors
			and: [ currentTokenFirst == $_ 
			and: [ currentToken notNil
			and: [ currentToken size > 1 ] ] ] ]) 
		and: [ currentToken last isAlphaNumeric
			or: [ allowUnderscoreSelectors
				and: [ currentToken last == $_ ] ] ] ! !

!SHParserST80 methodsFor: 'character testing' stamp: 'ul 5/1/2015 13:43'!
isSelectorCharacter: aCharacter

	| asciiValue |
	('"#$'':().;[]{}^_'  includes: aCharacter) ifTrue: [ ^false ].
	aCharacter isSeparator ifTrue:[ ^false ].
	aCharacter isAlphaNumeric ifTrue: [ ^false ].
	(asciiValue := aCharacter asciiValue) = 30 ifTrue: [ ^false "the doIt char" ].
	^asciiValue ~= 0 "Any other char, but 0 is ok as a binary selector char."
! !

!SHParserST80 methodsFor: 'token testing' stamp: 'tween 4/28/2004 09:43'!
isTokenExternalFunctionCallingConvention
	| descriptorClass |
	descriptorClass := Smalltalk at: #ExternalFunction ifAbsent: [nil].
	descriptorClass == nil ifTrue: [^false].
	^(descriptorClass callingConventionFor: currentToken) notNil! !

!SHParserST80 methodsFor: 'parse support' stamp: 'tween 4/28/2004 09:48'!
leaveBlock
	arguments removeKey: blockDepth ifAbsent: [].
	temporaries removeKey: blockDepth ifAbsent: [].
	blockDepth := blockDepth - 1.
	bracketDepth := bracketDepth - 1! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 4/26/2015 18:29'!
nextChar
	
	^source at: (sourcePosition := sourcePosition + 1) ifAbsent: $ ! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 5/5/2015 00:56'!
parse
	"Parse the receiver's text as a Smalltalk method"

	self parse: (parseAMethod ifNil: [ classOrMetaClass notNil ]).
	errorBlock := nil! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 4/26/2015 19:32'!
parse: isAMethod 
	"Parse the receiver's text. If isAMethod is true
    then treat text as a method, if false as an
    expression with no message pattern"

	self initializeInstanceVariables.
	allowUnderscoreAssignments := Scanner allowUnderscoreAsAssignment.
	allowUnderscoreSelectors := Scanner prefAllowUnderscoreSelectors.
	sourcePosition := 1.
	arguments := Dictionary new.
	temporaries := Dictionary new.
	blockDepth := bracketDepth := 0.
	ranges
		ifNil: [ ranges := OrderedCollection new: 40 "Covers over 80% of all methods." ]
		ifNotNil: [ ranges reset ].
	errorBlock := [^false].
	self scanNext.
	isAMethod ifTrue: [
		self
			parseMessagePattern;
			parsePragmaSequence ].
	self parseMethodTemporaries.
	isAMethod ifTrue: [ self parsePragmaSequence ].
	self parseStatementList.
	currentToken ifNotNil: [ self error ].
	^true! !

!SHParserST80 methodsFor: 'accessing' stamp: 'ul 5/5/2015 00:55'!
parseAMethod: aBoolean

	parseAMethod := aBoolean! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:38'!
parseArray
	[currentTokenFirst == $)] whileFalse: [self parseLiteralArrayElement].
	self scanPast: #arrayEnd! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 4/28/2010 20:22'!
parseBinary 
	| binary type |
	self parseUnary.
	[self isBinary] 
		whileTrue: [
			binary := currentToken.
			type := #binary.
			(binary isEmpty or:[(Symbol lookup: binary) notNil])
				ifFalse:[
					type := (Symbol thatStartsCaseSensitive: binary skipping: nil)
						ifNil: [#undefinedBinary]
						ifNotNil:[#incompleteBinary]].	
			self scanPast: type. 	
			self parseTerm.
            	self parseUnary]
! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 8/7/2005 14:26'!
parseBinaryMessagePattern   

   	self scanPast:  #patternBinary. 
	self failUnless: self isName.
	self scanPast: #patternArg.

! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:39'!
parseBlock
	self enterBlock.
	self scanPast: #blockStart level: bracketDepth.
	currentTokenFirst == $: ifTrue: [self parseBlockArguments].
	currentTokenFirst == $| ifTrue: [self parseBlockTemporaries].
	self parseStatementList.
	self failUnless: currentTokenFirst == $].
	self scanPast: #blockEnd level: bracketDepth.
	self leaveBlock! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:39'!
parseBlockArguments
	[currentTokenFirst == $:] 
		whileTrue: [
			self scanPast: #blockArgColon.
			self failUnless: self isName.
			self scanPast: #blockPatternArg].
	currentTokenFirst == $| 
		ifTrue: [^self scanPast: #blockArgsBar]! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:42'!
parseBlockTemporaries
	currentTokenFirst == $| 
		ifTrue: [
			self scanPast: #blockTempBar.
			[self isName] 
				whileTrue: [self scanPast: #blockPatternTempVar].
			self failUnless: currentToken = '|'.
			self scanPast: #blockTempBar]! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:40'!
parseBraceArray
	self parseStatementListForBraceArray.
	self failUnless: currentTokenFirst == $}.
	self scanPast: #rightBrace! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 5/1/2015 13:43'!
parseByteArray

	[currentTokenFirst == $]] whileFalse: [
		currentTokenFirst isDigit
			ifTrue: [
				"do not parse the number, can be time consuming"
				self scanPast: #number]
			ifFalse: [
				self failWhen: currentTokenFirst == $. .
				self error]].
	self scanPast: #byteArrayEnd! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:40'!
parseCascade
	self parseKeyword.
	[currentTokenFirst == $;] 
		whileTrue: [
			self scanPast: #cascadeSeparator.
			self parseKeyword]! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 4/28/2004 14:28'!
parseCharSymbol
	| s e |
	s := sourcePosition - 1.
	e := sourcePosition.
	self nextChar.
	self scanPast: #symbol start: s end: e! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 4/28/2004 13:51'!
parseExpression
	| assignType |
	self isName 
		ifTrue: [
			self scanPast: (self resolve: currentToken).
			self isAssignment 
				ifTrue: [
					assignType := self isAnsiAssignment 
						ifTrue: [#ansiAssignment]
						ifFalse: [#assignment].
					self scanPast: assignType.
					self parseExpression]
				ifFalse: [self parseCascade]]
		ifFalse: [
			self parseTerm.
			self parseCascade]! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 5/1/2015 13:43'!
parseExternalCall
	[self scanNext.
	((Smalltalk at: #ExternalFunction) callingConventionModifierFor: currentToken) notNil]
		whileTrue.
	self failUnless: currentToken notNil.
	self scanPast: #externalCallType.
	currentToken = '*' 
		ifTrue: [self scanPast: #externalCallTypePointerIndicator].
	currentTokenFirst isDigit
		ifTrue: [self scanPast: #integer]
		ifFalse: 	[
			self failUnless: currentTokenFirst == $'.
			self parseString].
	self failUnless: currentTokenFirst == $(.
	self scanPast: #leftParenthesis.
	[currentTokenFirst ~= $)] 
		whileTrue: [
			self failUnless: currentToken notNil.
			self scanPast: #externalCallType.
			currentToken = '*' 
				ifTrue: [self scanPast: #externalCallTypePointerIndicator]].
	self scanPast: #rightParenthesis.
	currentToken = 'module:' 
		ifTrue: [
			self scanPast: #module.
			self parseStringOrSymbol ].
	currentToken = 'error:' ifTrue: [
		self scanPast: #primitive. "there's no rangeType for error"
		self isName
			ifTrue: [ self scanPast: #patternTempVar ]
			ifFalse: [ self parseStringOrSymbol ] ].
	self failUnless: currentToken = '>'.
	self scanPast: #primitiveOrExternalCallEnd! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 4/28/2010 20:22'!
parseKeyword 
    | keyword rangeIndices |
    self parseBinary.
	keyword := ''.
	rangeIndices := #().
	[
    		[self isKeyword]
        		whileTrue: [
				keyword := keyword, currentToken. 
				self rangeType: #keyword.
				"remember where this keyword token is in ranges"
				rangeIndices := rangeIndices copyWith: ranges size.
				self scanNext.
				self parseTerm.
				self parseBinary ]
	] ensure: [ | type |
		"do this in an ensure so that it happens even if the errorBlock evaluates before getting here"
		"patch up the keyword tokens, so that incomplete and undefined ones look different"
		(keyword isEmpty or:[(Symbol lookup: keyword) notNil])
			ifFalse:[
				type := (Symbol thatStartsCaseSensitive: keyword skipping: nil)
					ifNil: [#undefinedKeyword]
					ifNotNil:[#incompleteKeyword].
				rangeIndices do: [:i | (ranges at: i) type: type]]]! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 8/7/2005 14:27'!
parseKeywordMessagePattern   

	[self isKeyword]
		whileTrue: [ 
			self scanPast:  #patternKeyword. 
			self failUnless: self isName.
			self scanPast: #patternArg]

! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 5/1/2015 13:45'!
parseLiteral: inArray

	currentTokenFirst == $$ 
		ifTrue: [
			| pos |
			self failWhen: self currentChar isNil.
			self rangeType: #'$'.
			pos := currentTokenSourcePosition + 1.
			self nextChar.
			^self scanPast: #character start: pos end: pos].
	currentTokenFirst isDigit
		ifTrue: [
			"do not parse the number, can be time consuming"
			^self scanPast: #number].
	currentToken = '-' 
		ifTrue: [
			| c |
			c := self currentChar.
			(inArray and: [c isNil or: [ c isDigit not ]]) 
				ifTrue: [
					"single - can be a symbol in an Array"
					^self scanPast: #symbol].
			self scanPast: #-.
			self failWhen: currentToken isNil.
			"token isNil ifTrue: [self error: 'Unexpected End Of Input']."
			"do not parse the number, can be time consuming"
			^self scanPast: #number].
	currentTokenFirst == $' ifTrue: [^self parseString].
	currentTokenFirst == $# ifTrue: [^self parseSymbol].
	(inArray and: [currentToken notNil]) ifTrue: [^self scanPast: #symbol].
	self failWhen: currentTokenFirst == $. .
	self error	": 'argument missing'"! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 5/1/2015 13:44'!
parseLiteralArrayElement

	currentTokenFirst isLetter ifTrue: [
		#true = currentToken ifTrue: [ ^self scanPast: #true ].
		#false = currentToken ifTrue: [ ^self scanPast: #false ].
		#nil = currentToken ifTrue: [ ^self scanPast: #nil ].
		^self scanPast: #symbol ].
	currentTokenFirst == $( ifTrue: [
		self scanPast: #arrayStart.
		^self parseArray ].
	^self parseLiteral: true! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 8/7/2005 14:28'!
parseMessagePattern   

	self isName 
		ifTrue: [self parseUnaryMessagePattern]
		ifFalse: [
			self isBinary
				ifTrue:[self parseBinaryMessagePattern]
				ifFalse:[
					self failUnless: self isKeyword.
					self parseKeywordMessagePattern]]! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:44'!
parseMethodTemporaries
	currentTokenFirst == $| 
		ifTrue: [
			self scanPast: #methodTempBar.
			[self isName] 
				whileTrue: [self scanPast: #patternTempVar].
			self failUnless: currentToken = '|'.
			self scanPast: #methodTempBar]! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 12/29/2006 11:13'!
parsePragmaBinary

	self scanPast: #pragmaBinary.
	self isName
		ifTrue:[self scanPast: (self resolvePragmaArgument: currentToken)] 
		ifFalse:[	self parseLiteral: false].
	self failUnless: currentToken = '>'.
	self scanPast: #primitiveOrExternalCallEnd! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 7/2/2006 12:59'!
parsePragmaKeyword

	[self isKeyword]
		whileTrue:[
			self scanPast: #pragmaKeyword.
			self isName
				ifTrue:[self scanPast: (self resolvePragmaArgument: currentToken)] 
				ifFalse:[	self parseLiteral: false]].
	self failUnless: currentToken = '>'.
	self scanPast: #primitiveOrExternalCallEnd! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 12/29/2006 11:11'!
parsePragmaSequence
	[currentToken = '<' ]
		whileTrue:[
			self scanPast: #primitiveOrExternalCallStart.
			currentToken = 'primitive:' 
				ifTrue: [
					self rangeType: #primitive.
					self parsePrimitive]
				ifFalse:[
					self isTokenExternalFunctionCallingConvention 
						ifTrue: [
							self rangeType: #externalFunctionCallingConvention.
							self parseExternalCall]
						ifFalse:[
							self isName
								ifTrue:[
									self scanPast: #pragmaUnary.
									self failUnless: currentToken = '>'.
									self scanPast: #primitiveOrExternalCallEnd]
								ifFalse:[
									self isKeyword
										ifTrue:[
											self parsePragmaKeyword]
										ifFalse:[
											self isBinary
												ifTrue:[self parsePragmaBinary]
												ifFalse:[	self error	": 'Invalid External Function Calling convention'" ]]]]]]! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 5/1/2015 13:45'!
parsePrimitive

	self scanNext.
	currentTokenFirst isDigit
		ifTrue: [ self scanPast: #integer ]
		ifFalse: [
			self parseStringOrSymbol.
			currentToken = 'module:' ifTrue: [
				self scanPast: #module.
				self parseStringOrSymbol ] ].
	currentToken = 'error:' ifTrue: [
		self scanPast: #primitive. "there's no rangeType for error"
		self isName
			ifTrue: [ self scanPast: #patternTempVar ]
			ifFalse: [ self parseStringOrSymbol ] ].
	self failUnless: currentToken = '>'.
	self scanPast: #primitiveOrExternalCallEnd! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:44'!
parseStatement
	currentTokenFirst == $^ ifTrue: [self scanPast: #return].
	self parseExpression! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:45'!
parseStatementList
	
	[[currentTokenFirst == $.] whileTrue: [self scanPast: #statementSeparator].
	(currentToken notNil and: [currentTokenFirst ~~ $]]) 
		ifTrue: [self parseStatement].
	currentTokenFirst == $.] 
			whileTrue: [self scanPast: #statementSeparator]! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:45'!
parseStatementListForBraceArray
	"same as parseStatementList, but does not allow empty statements e.g {...$a...}.
	A single terminating . IS allowed e.g. {$a.} "

	
	[currentTokenFirst ~~ $} ifTrue: [self parseStatement].
	currentTokenFirst == $.] 
		whileTrue: [self scanPast: #statementSeparator]! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 2/10/2014 12:18'!
parseString
	| first c last |
	first := sourcePosition.
	
	[(c := self currentChar)
		ifNil: [
			self rangeType: #unfinishedString start: first - 1 end: source size.
			self error	": 'unfinished string'"].
	c ~~ $' or: [
		self peekChar == $' 
			ifTrue: [
				sourcePosition := sourcePosition + 1.
				true]
			ifFalse: [false]]
	] whileTrue: [sourcePosition := sourcePosition + 1].
	last := sourcePosition.
	self nextChar.
	self scanPast: #string start: first - 1 end: last! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 10/12/2010 02:43'!
parseStringOrSymbol

	currentTokenFirst == $' ifTrue: [ ^self parseString ].
	currentTokenFirst == $# ifTrue: [ ^self parseSymbol ].
	self error! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 5/1/2015 13:45'!
parseSymbol
	| c |
	currentToken = '#' 
		ifTrue: [
			"if token is just the #, then scan whitespace and comments
			and then process the next character.
			Squeak allows space between the # and the start of the symbol 
			e.g. # (),  #  a, #  'sym' "
			self rangeType: #symbol.
			self scanWhitespace].
	c := self currentChar.
	self failWhen: (c isNil or: [c isSeparator]).
	c == $( 
		ifTrue: [
			self nextChar.
			self scanPast: #arrayStart start: currentTokenSourcePosition end: currentTokenSourcePosition + 1.
			^self parseArray].
	c == $' ifTrue: [^self parseSymbolString].
	c == $[ ifTrue: [
			self nextChar.
			self scanPast: #byteArrayStart start: currentTokenSourcePosition end: currentTokenSourcePosition + 1.
			^self parseByteArray].
	((self isSelectorCharacter: c) or: [c == $-]) 
		ifTrue: [^self parseSymbolSelector].
	(c isLetter
		or: [ c == $: 
		or: [ allowUnderscoreSelectors and: [ c == $_ ] ] ]) 
			ifTrue: [^self parseSymbolIdentifier].
	^self parseCharSymbol! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 5/1/2015 13:46'!
parseSymbolIdentifier

	| c start end |
	c := self currentChar.
	self failUnless: (
		c isLetter
			or: [ c == $: 
			or: [ allowUnderscoreSelectors and: [ c == $_ ] ] ]).
	start := sourcePosition.	
	[
		(c := self nextChar) isAlphaNumeric
			or: [ c == $:
			or: [ allowUnderscoreSelectors and: [ c == $_ ] ] ] ] whileTrue.
	end := sourcePosition - 1.
	c := source copyFrom: start - 1 to: end.
	self scanPast: #symbol start: start - 1 end: end.
	^c! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 4/28/2004 14:06'!
parseSymbolSelector
	| start end |
	start := sourcePosition - 1.
	end := sourcePosition.
	[self isSelectorCharacter: self nextChar] 
		whileTrue: [end := sourcePosition].
	self scanPast: #symbol start: start end: end! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 4/28/2010 20:26'!
parseSymbolString
	| first c last |
	first := sourcePosition.
	self nextChar.
	[(c := self currentChar) 
		ifNil: [
			self rangeType: #unfinishedString start: first end: source size.
			self error	": 'unfinished string'"].
	c ~~ $' or: [
		self peekChar == $' 
			ifTrue: [sourcePosition := sourcePosition + 1.true] 
			ifFalse: [false]]
	] whileTrue: [sourcePosition := sourcePosition + 1].
	last := sourcePosition.
	self nextChar.
	self scanPast: #stringSymbol start: first - 1 end: last! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 2/17/2007 14:47'!
parseTerm
	self failWhen: currentToken isNil.
	currentTokenFirst == $( 
		ifTrue: [
			bracketDepth := bracketDepth + 1.
			self scanPast: #leftParenthesis level: bracketDepth.
			self parseExpression.
			self failUnless: currentTokenFirst == $).
			self scanPast: #rightParenthesis level: bracketDepth.
			^bracketDepth := bracketDepth - 1].
	currentTokenFirst == $[ ifTrue: [^self parseBlock].
	currentTokenFirst == ${ 
		ifTrue: [
			self scanPast: #leftBrace.
			^self parseBraceArray].
	self isName ifTrue: [^self scanPast: (self resolve: currentToken)].
	self parseLiteral: false! !

!SHParserST80 methodsFor: 'parse' stamp: 'ul 4/28/2010 20:26'!
parseUnary
	| unary type |
	
    [self isName]
        whileTrue: [
			unary := currentToken.
			type := #unary.
			(unary isEmpty or:[(Symbol lookup: unary) notNil])
				ifFalse:[
					type := (Symbol thatStartsCaseSensitive: unary skipping: nil)
						ifNil: [#undefinedUnary]
						ifNotNil:[#incompleteUnary]].
			self scanPast: type]
! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 4/17/2004 22:17'!
parseUnaryMessagePattern
	
	 self scanPast: #patternUnary
! !

!SHParserST80 methodsFor: 'token testing' stamp: 'ul 4/5/2015 16:20'!
parsingBlockArguments
	^ranges notEmpty and: [ranges last type == #blockPatternArg]! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 4/26/2015 18:30'!
peekChar

	^source at: sourcePosition + 1 ifAbsent: $ ! !

!SHParserST80 methodsFor: 'parse support' stamp: 'tween 4/28/2004 10:03'!
pushArgument: aString 
	(arguments at: blockDepth ifAbsentPut: [OrderedCollection new: 10]) 
		add: aString! !

!SHParserST80 methodsFor: 'parse support' stamp: 'ul 4/26/2015 17:59'!
pushTemporary: aString

	(temporaries at: blockDepth ifAbsentPut: [ OrderedCollection new ]) 
		add: aString! !

!SHParserST80 methodsFor: 'recording ranges' stamp: 'tween 4/28/2004 09:54'!
rangeType: aSymbol 
	^self 
		rangeType: aSymbol
		start: currentTokenSourcePosition
		end: currentTokenSourcePosition + currentToken size - 1! !

!SHParserST80 methodsFor: 'recording ranges' stamp: 'tween 4/28/2004 10:20'!
rangeType: aSymbol start: s end: e 
	^ranges add: (SHRange start: s end: e type: aSymbol)! !

!SHParserST80 methodsFor: 'accessing' stamp: 'ul 11/15/2010 04:14'!
ranges

	^ranges! !

!SHParserST80 methodsFor: 'parse' stamp: 'tween 8/26/2004 03:07'!
rangesIn: sourceString classOrMetaClass: aBehaviour workspace: aWorkspace  environment: anEnvironmentOrNil
	anEnvironmentOrNil ifNotNil: [environment := anEnvironmentOrNil].
	self
		workspace: aWorkspace;
		classOrMetaClass: aBehaviour;
		source: sourceString.
	self parse.
	^ranges! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'ul 4/26/2015 18:28'!
resolve: aString

	aString = #self ifTrue: [ ^#self ].
	aString = #true ifTrue: [ ^#true ].
	aString = #false ifTrue: [ ^#false ].
	aString = #nil ifTrue: [ ^#nil ].
	aString = #super ifTrue: [ ^#super ].
	aString = #thisContext ifTrue: [ ^#thisContext ].
	(self isBlockTempName: aString) ifTrue: [^#blockTempVar].
	(self isBlockArgName: aString) ifTrue: [^#blockArg].
	(self isMethodTempName: aString) ifTrue: [^#tempVar].
	(self isMethodArgName: aString) ifTrue: [^#methodArg].
	(instanceVariables includes: aString) ifTrue: [^#instVar].
	workspace 
		ifNotNil: [(workspace hasBindingOf: aString) ifTrue: [^#workspaceVar]].
	(Symbol lookup: aString) ifNotNil: [:sym | 
		classOrMetaClass
			ifNotNil: [
				classOrMetaClass theNonMetaClass withAllSuperclassesDo: [:c | 
					(c classPool bindingOf: sym) ifNotNil: [^#classVar].
					c sharedPools do: [:p | (p bindingOf: sym) ifNotNil: [^#poolConstant]].
					(c environment bindingOf: sym) ifNotNil: [^#globalVar]]]
			ifNil: [(environment bindingOf: sym) ifNotNil: [^#globalVar]]].
	^self resolvePartial: aString! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'ul 5/2/2015 13:34'!
resolvePartial: aString 
	"check if any identifier begins with aString"
	
	(#('self' 'super' 'true' 'false' 'nil' 'thisContext') anySatisfy: [:each | each beginsWith: aString]) 
		ifTrue: [^#incompleteIdentifier].
	(self isIncompleteBlockTempName: aString) ifTrue: [^#incompleteIdentifier].
	(self isIncompleteBlockArgName: aString) ifTrue: [^#incompleteIdentifier].
	(self isIncompleteMethodTempName: aString) ifTrue: [^#incompleteIdentifier].
	(self isIncompleteMethodArgName: aString) ifTrue: [^#incompleteIdentifier].
	(instanceVariables anySatisfy: [:each | each beginsWith: aString]) ifTrue: [^#incompleteIdentifier].
	workspace 
		ifNotNil: [(workspace hasBindingThatBeginsWith: aString) ifTrue: [^#incompleteIdentifier]].
	classOrMetaClass
		ifNotNil: [
			classOrMetaClass theNonMetaClass withAllSuperclassesDo: [:c | 
				(c classPool hasBindingThatBeginsWith: aString) ifTrue: [^#incompleteIdentifier].
				c sharedPools do: [:p | (p hasBindingThatBeginsWith: aString) ifTrue: [^#incompleteIdentifier]].
				(c environment hasBindingThatBeginsWith: aString) ifTrue: [^#incompleteIdentifier]]]
		ifNil: [(environment hasBindingThatBeginsWith: aString) ifTrue: [^#incompleteIdentifier]].
	^#undefinedIdentifier! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'ul 5/2/2015 13:34'!
resolvePartialPragmaArgument: aString 
	"check if any valid pragma argument begins with aString"
	
	(#('true' 'false' 'nil') anySatisfy: [:each | each beginsWith: aString]) 
		ifTrue: [^#incompleteIdentifier].
	"should really check that a matching binding is for a Class?"
	classOrMetaClass
		ifNotNil: [
			classOrMetaClass theNonMetaClass withAllSuperclassesDo: [:c | 
				(c environment hasBindingThatBeginsWith: aString) ifTrue: [^#incompleteIdentifier]]]
		ifNil: [(environment hasBindingThatBeginsWith: aString) ifTrue: [^#incompleteIdentifier]].
	^#undefinedIdentifier! !

!SHParserST80 methodsFor: 'identifier testing' stamp: 'ul 5/2/2015 13:34'!
resolvePragmaArgument: aString 
	(#('true' 'false' 'nil') includes: aString) ifTrue: [^aString asSymbol].
	"should really check that global is a class?"
	(Symbol lookup: aString) ifNotNil: [:sym | 
		classOrMetaClass 
			ifNotNil: [
				classOrMetaClass theNonMetaClass withAllSuperclassesDo: [:c | 
					(c environment bindingOf: sym) ifNotNil: [^#globalVar]]]
			ifNil: [(environment bindingOf: sym) ifNotNil: [^#globalVar]]].
	^self resolvePartialPragmaArgument: aString! !

!SHParserST80 methodsFor: 'scan' stamp: 'eem 2/3/2015 11:08'!
scanBinary
	| c d |
	c := self currentChar.
	currentTokenSourcePosition := sourcePosition.
	currentToken := c asString.
	d := self nextChar.
	((self isSelectorCharacter: c) or: [c == $:]) ifFalse: [^currentToken].
	(c == $: and: [d == $=]) ifTrue: " := assignment"
		[currentToken := currentToken , d asString.
		 self nextChar.
		 ^currentToken].
	((c == $|) and: [self parsingBlockArguments]) ifTrue:
		[^currentToken].
	[self isSelectorCharacter: d] whileTrue:
		[currentToken := currentToken , d asString.
		 d := self nextChar].
	^currentToken! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 4/26/2015 18:40'!
scanComment

	| start |
	start := sourcePosition.
	(sourcePosition := source indexOf: $" startingAt: start + 1) = 0 ifTrue: [
		sourcePosition := source size + 1.
		self rangeType: #unfinishedComment start: start end: source size.
		^self error ].
	start < sourcePosition ifTrue: [
		self rangeType: #comment start: start end: sourcePosition ].
	self 
		nextChar;
		scanWhitespace! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 5/1/2015 13:46'!
scanIdentifier

	| c start |
	start := sourcePosition.
	[
		(c := self nextChar) isAlphaNumeric
			or: [ allowUnderscoreSelectors and: [ c == $_ ] ] ] whileTrue.
	(c == $: and: [ (self isSelectorCharacter: self peekChar) not ]) 
		ifTrue: [ self nextChar ].
	currentToken := source copyFrom: start to: sourcePosition - 1.
	currentTokenSourcePosition := start! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 5/1/2015 13:46'!
scanNext

	self scanWhitespace.
	currentTokenFirst := self currentChar ifNil: [
		" end of input "
		currentTokenFirst := $ .
		currentTokenSourcePosition := nil.
		currentToken := nil.
		^nil ].
	currentTokenFirst isDigit ifTrue: [ ^self scanNumber ].
	(currentTokenFirst isLetter or: [
		allowUnderscoreSelectors and: [ currentTokenFirst == $_ ] ])
			ifTrue: [ ^self scanIdentifier ].
	^self scanBinary! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 5/1/2015 13:48'!
scanNumber
	| start c nc base |
	start := sourcePosition.
	self skipDigits.
	c := self currentChar.
	c == $r 
		ifTrue: [
			base := Integer readFrom: (ReadStream on: (source copyFrom: start to: sourcePosition - 1)).
			self peekChar == $- ifTrue:[self nextChar].
			self skipBigDigits: base.
			c := self currentChar.
			c == $. 
				ifTrue: [
					(self isBigDigit: self nextChar base: base) 
						ifFalse: [sourcePosition := sourcePosition - 1]
						ifTrue: [self skipBigDigits: base]].
			c := self currentChar.
			('deq'includes: c) 
				ifTrue: [
					((nc := self nextChar) isDigit or: [nc == $- and: [ self peekChar isDigit ]]) 
						ifFalse: [sourcePosition := sourcePosition - 1]
						ifTrue: [self skipDigits]].
			c == $s ifTrue: [
				(nc := self nextChar) isDigit
					ifTrue: [ self skipDigits ]
					ifFalse: [ 
						nc isLetter ifTrue: [
							sourcePosition := sourcePosition - 1 ] ] ].
			currentToken := source copyFrom: start to: sourcePosition - 1.
			^currentTokenSourcePosition := start].
	c == $s 
		ifTrue: [
			(nc := self nextChar) isDigit
				ifFalse: [nc isLetter ifTrue: [sourcePosition := sourcePosition - 1]]
				ifTrue: [self skipDigits.].
			currentToken := source copyFrom: start to: sourcePosition - 1.
			^currentTokenSourcePosition := start].
	c == $. 
		ifTrue: [
			self nextChar isDigit
				ifFalse: [
					sourcePosition := sourcePosition - 1.
					currentToken := source copyFrom: start to: sourcePosition - 1.
					^currentTokenSourcePosition := start]
				ifTrue: [self skipDigits]].
	c := self currentChar.
	('deq' includes: c) 
		ifTrue: [
			((nc := self nextChar) isDigit or: [nc == $-  and:[ self peekChar isDigit ]]) 
				ifFalse: [sourcePosition := sourcePosition - 1]
				ifTrue: [self skipDigits]].
	c == $s 
		ifTrue: [
			(nc := self nextChar) isDigit
				ifFalse: [nc isLetter ifTrue: [sourcePosition := sourcePosition - 1]]
				ifTrue: [self skipDigits]].
	currentToken := source copyFrom: start to: sourcePosition - 1.
	^currentTokenSourcePosition := start! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 2/10/2014 17:16'!
scanPast: rangeType 
	"record rangeType for current token .
	record argument and temp declarations.
	scan and answer the next token"
	rangeType == #blockPatternArg ifTrue: [self pushArgument: currentToken].
	rangeType == #blockPatternTempVar ifTrue: [self pushTemporary: currentToken].
	rangeType == #patternArg ifTrue: [self pushArgument: currentToken].
	rangeType == #patternTempVar ifTrue: [self pushTemporary: currentToken].
	^self
		rangeType: rangeType;
		scanNext! !

!SHParserST80 methodsFor: 'scan' stamp: 'tween 4/28/2004 14:17'!
scanPast: rangeType level: level
	"first level adds no suffix to the rangeType.
	Suffix from 1 to 7 added in cycles , ((level-2) mod(7) + 1)"
	| cycle typePlusCycle |
	
	cycle := level <= 1 
		ifTrue: [0]
		ifFalse:[ ((level - 2) \\ 7) + 1].
	typePlusCycle := cycle = 0 
		ifTrue:[rangeType]
		ifFalse:[(rangeType, cycle asString) asSymbol].
	^self scanPast: typePlusCycle
! !

!SHParserST80 methodsFor: 'scan' stamp: 'tween 4/28/2004 09:56'!
scanPast: rangeType start: startInteger end: endInteger
	"record rangeType for current token from startInteger to endInteger,
	 and scanNext token"

	^self 
		rangeType: rangeType start: startInteger end: endInteger;
		scanNext
	
! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 4/5/2015 23:12'!
scanWhitespace
	
	(self currentChar ifNil: [ ^self ]) isSeparator ifTrue: [
		sourcePosition := source
			indexOfAnyOf: CharacterSet nonSeparators
			startingAt: sourcePosition + 1.
		sourcePosition = 0 ifTrue: [ "Not found"
			sourcePosition := source size + 1 ] ].
	self currentChar == $" ifTrue: [ self scanComment ]! !

!SHParserST80 methodsFor: 'scan' stamp: 'tween 8/6/2005 13:20'!
skipBigDigits: baseInteger
	[self isBigDigit: self nextChar base: baseInteger] 
		whileTrue: []
! !

!SHParserST80 methodsFor: 'scan' stamp: 'ul 5/1/2015 13:48'!
skipDigits

	[ self nextChar isDigit ] whileTrue! !

!SHParserST80 methodsFor: 'accessing' stamp: 'tween 4/17/2004 22:21'!
source
	^source! !

!SHParserST80 methodsFor: 'accessing' stamp: 'ul 5/1/2015 13:49'!
source: aString
	
	source := aString
	! !

!SHParserST80 methodsFor: 'accessing' stamp: 'tween 4/15/2004 13:18'!
workspace: aWorkspace
    workspace := aWorkspace! !

Object subclass: #SHRange
	instanceVariableNames: 'start end type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoutCore-Parsing'!

!SHRange commentStamp: 'tween 8/16/2004 15:16' prior: 0!
I associate a type with a range of characters in a String
I have these instance variables...
	start - the one based index of the first character of the range within the String.
	end - the one based index of the last character  of the range within the String.
	type - a Symbol describing the type of the range
	
A sequence of instances of me are created by an instance of SHParserST80 which can then used by an instance of  SHTextStyler to style Text. !

!SHRange class methodsFor: 'instance creation' stamp: 'tween 2/17/2007 14:04'!
start: s end: e type: aSymbol
	
	^self new
		start: s end: e type: aSymbol;
		yourself! !

!SHRange methodsFor: 'accessing' stamp: 'tween 4/13/2004 18:55'!
end
	^end! !

!SHRange methodsFor: 'accessing' stamp: 'tween 4/13/2004 18:55'!
end: anInteger
	end := anInteger! !

!SHRange methodsFor: 'accessing' stamp: 'tween 4/24/2004 15:48'!
length
	^end - start + 1! !

!SHRange methodsFor: 'accessing' stamp: 'ul 7/26/2014 10:41'!
printOn: stream

	super printOn: stream.
	stream
		nextPut: $(;
		print: type;
		nextPutAll: ', ';
		print: start;
		nextPutAll: ', ';
		print: end;
		nextPut: $)! !

!SHRange methodsFor: 'accessing' stamp: 'tween 4/13/2004 18:54'!
start
	^start! !

!SHRange methodsFor: 'accessing' stamp: 'tween 4/13/2004 18:54'!
start: anInteger
	start := anInteger! !

!SHRange methodsFor: 'accessing' stamp: 'tween 2/17/2007 14:03'!
start: startInteger end: endInteger type: typeSymbol
	start := startInteger.
	end := endInteger.
	type := typeSymbol! !

!SHRange methodsFor: 'accessing' stamp: 'tween 4/13/2004 18:55'!
type
	^type! !

!SHRange methodsFor: 'accessing' stamp: 'tween 4/13/2004 18:55'!
type: aSymbol
	type := aSymbol! !

Object subclass: #SHTextStyler
	instanceVariableNames: 'sem backgroundProcess text monitor view stylingEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoutCore-Styling'!

!SHTextStyler commentStamp: 'tween 8/27/2004 10:54' prior: 0!
I am an Abstract class.
Subclasses of me can create formatted, coloured, and styled copies of Text that is given to them.
They may perform their styling asynchronously, in a background process which I create and manage.

My public interface is...

	view: aViewOrMorph - set the view that will receive notifications when styling has completed.
	
	format: aText - modifies aText's string

	style: aText - modifies the TextAttributes of aText, but does not change the string, then sends #stylerStyled: to the view.

	styleInBackgroundProcess: aText - performs style: in a background process, then sends #stylerStylednBackground: to the view.

	styledTextFor: aText - answers a formatted and styled copy of aText

	unstyledTextFrom: aText - answers a copy of aText with all TextAttributes removed

Subclasses of me should re-implement...

	privateFormat: aText - answer a formatted version of aText; the String may be changed
	privateStyle: aText - modify the TextAttributes of aText; but do not change the String
	

	
	
!

!SHTextStyler methodsFor: 'styling' stamp: 'lr 4/8/2010 15:56'!
evaluateWithoutStyling: aBlock
	| t |
	t := stylingEnabled.
	stylingEnabled := false.
	^ aBlock ensure: [stylingEnabled := t]! !

!SHTextStyler methodsFor: 'formatting' stamp: 'tween 8/26/2004 02:19'!
format: aText
	"Answer a copy of <aText> which has been reformatted,
	or <aText> if no formatting is to be applied"
	
	self terminateBackgroundStylingProcess.
	^self privateFormat: aText! !

!SHTextStyler methodsFor: 'styling' stamp: 'tween 8/28/2004 00:21'!
initialize
	stylingEnabled := true
! !

!SHTextStyler methodsFor: 'private' stamp: 'ul 4/28/2010 20:27'!
monitor
	^monitor ifNil: [monitor := Monitor new]! !

!SHTextStyler methodsFor: 'private' stamp: 'tween 8/26/2004 02:26'!
privateFormat: aText
	self shouldBeImplemented! !

!SHTextStyler methodsFor: 'private' stamp: 'tween 8/26/2004 02:25'!
privateStyle: aText

	self shouldBeImplemented! !

!SHTextStyler methodsFor: 'styling' stamp: 'tween 8/30/2004 12:32'!
style: aText
	self terminateBackgroundStylingProcess.
	stylingEnabled ifTrue:[
		text := aText copy.
		self privateStyle: text.
		view ifNotNil:[view stylerStyled: text] ]! !

!SHTextStyler methodsFor: 'styling' stamp: 'tween 8/30/2004 12:32'!
styleInBackgroundProcess: aText

	self terminateBackgroundStylingProcess.
	stylingEnabled ifTrue:[
		text := aText copy.
		self monitor critical: [
			sem := Semaphore new. 
			[sem notNil
				ifTrue: [
					sem wait.
					view ifNotNil:[view stylerStyledInBackground: text]]
			] forkAt: Processor activePriority.
			backgroundProcess := 
				[self privateStyle: text.
				sem signal]
					forkAt: Processor userBackgroundPriority] ]
	! !

!SHTextStyler methodsFor: 'styling' stamp: 'tween 8/26/2004 02:30'!
styledTextFor: aText
	"Answer a copy of aText that is both formatted and styled"	
	| formattedText |
	
	formattedText := self privateFormat: aText.
	self privateStyle: formattedText.
	^formattedText! !

!SHTextStyler methodsFor: 'private' stamp: 'tween 4/9/2004 12:21'!
terminateBackgroundStylingProcess
	self monitor critical: [
		backgroundProcess 
			ifNotNil: [
				backgroundProcess terminate.
				backgroundProcess := nil].
		sem 
			ifNotNil:[
				sem terminateProcess.
				sem := nil].	
	]		! !

!SHTextStyler methodsFor: 'styling' stamp: 'tween 8/26/2004 02:47'!
unstyledTextFrom: aText
	
	^Text fromString: aText string! !

!SHTextStyler methodsFor: 'copying' stamp: 'cmm 4/26/2011 14:29'!
veryDeepInner: aDeepCopier
	super veryDeepInner: aDeepCopier.
	sem := backgroundProcess := monitor := nil.
	text := text veryDeepCopyWith: aDeepCopier.
	view := view veryDeepCopyWith: aDeepCopier! !

!SHTextStyler methodsFor: 'accessing' stamp: 'tween 8/26/2004 00:30'!
view: aViewOrMorph
	view := aViewOrMorph! !

SHTextStyler subclass: #SHTextStylerST80
	instanceVariableNames: 'classOrMetaClass workspace font parser formatAssignments environment sourceMap processedSourceMap pixelHeight attributesByPixelHeight parseAMethod'
	classVariableNames: 'SubduedSyntaxHighlights SyntaxHighlighting SyntaxHighlightingAsYouType SyntaxHighlightingAsYouTypeAnsiAssignment SyntaxHighlightingAsYouTypeLeftArrowAssignment'
	poolDictionaries: ''
	category: 'ShoutCore-Styling'!

SHTextStylerST80 class
	instanceVariableNames: 'styleTable textAttributesByPixelHeight'!

!SHTextStylerST80 commentStamp: 'tween 8/27/2004 10:55' prior: 0!
I style Smalltalk methods and expressions.

My 'styleTable' class instance var holds an array ofArrays which control how each token is styled/coloured. See my defaultStyleTable class method for its structure.
My styleTable can be changed by either modifying the defaultStyleTable class method and then executing SHTextStylerST80 initialize ; or by giving me a new styleTable through my #styleTable: class method.

My 'textAttributesByPixelSize' class instance var contains a dictionary of dictionaries.
	The key is a pixelSize and the value a Dictionary from token type Symbol to TextAttribute array.
	It is created/maintained automatically.
	
I also install these 3 preferences when my class initialize method is executed....
	#syntaxHighlightingAsYouType  - controls whether methods are styled in browsers
	#syntaxHighlightingAsYouTypeAnsiAssignment - controls whether assignments are formatted to be :=
	#syntaxHighlightingAsYouTypeLeftArrowAssignment - controls whether assignments are formatted to be _

I reimplement #unstyledTextFrom: so that TextActions are preserved in the unstyled text 
	
	
	
	
	 
	
!

SHTextStylerST80 class
	instanceVariableNames: 'styleTable textAttributesByPixelHeight'!

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'fbs 11/23/2013 16:16'!
ansiAssignmentPreferenceChanged
	"the user has changed the syntaxHighlightingAsYouTypeAnsiAssignment setting.
	If they have turned it on then force syntaxHighlightingAsYouTypeLeftArrowAssignment
	to be turned off"
	self syntaxHighlightingAsYouTypeAnsiAssignment 
		ifTrue: [self syntaxHighlightingAsYouTypeLeftArrowAssignment: false]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'tween 8/29/2004 19:12'!
attributeArrayForColor: aColorOrNil emphasis: anEmphasisSymbolOrArrayorNil font: aTextStyleOrFontOrNil
	"Answer a new Array containing any non nil TextAttributes specified"
	| answer emphArray |

	answer := Array new.
	aColorOrNil ifNotNil: [answer := answer, {TextColor color: aColorOrNil}].
	anEmphasisSymbolOrArrayorNil ifNotNil: [
		emphArray := anEmphasisSymbolOrArrayorNil isSymbol 
			ifTrue: [{anEmphasisSymbolOrArrayorNil}] 
			ifFalse: [anEmphasisSymbolOrArrayorNil].
		emphArray do: [:each |
			each ~= #normal
				ifTrue:[
					answer := answer, {TextEmphasis perform: each}]]].
	aTextStyleOrFontOrNil ifNotNil: [
		answer := answer, {TextFontReference toFont: aTextStyleOrFontOrNil}].
	^answer! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'ul 7/27/2014 07:27'!
attributesByPixelHeight: aNumber

	^self textAttributesByPixelHeight 
		at: aNumber 
		ifAbsent: [
			| result |
			result := self initialTextAttributesForPixelHeight: aNumber.
			" thread safety first "
			textAttributesByPixelHeight := textAttributesByPixelHeight copy
				at: aNumber put: result;
				yourself.
			result ]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'tween 2/17/2007 13:59'!
attributesFor: aSymbol pixelHeight: aNumber

	^(self textAttributesByPixelHeight 
		at: aNumber 
		ifAbsentPut:[self initialTextAttributesForPixelHeight: aNumber]) 
			at: aSymbol ifAbsent:[nil]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'ar 8/21/2009 21:47'!
chooseDefaultStyleTable
	"Choose the default style table"
	^self subduedSyntaxHighlights
		ifTrue:[self subduedStyleTable]
		ifFalse:[self defaultStyleTable]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'ul 1/28/2011 01:00'!
defaultStyleTable
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
^#(
	"(symbol	color		[emphasisSymbolOrArray		[textStyleName [pixelHeight]]])"		
	(default 								black 		)
	(invalid 								red 			)
	(excessCode 								red 			)
	(comment 								(green muchDarker) 		italic)
	(unfinishedComment 					(red muchDarker) 	italic)
	(#'$'									(red muchDarker) 	)
	(character								(red muchDarker) 	)
	(integer									(red muchDarker) 	)
	(number								(red muchDarker) 	)	
	(#-										(red muchDarker) 	)
	(symbol									(blue muchDarker)			bold)	
	(stringSymbol							(blue muchDarker)			bold)	
	(literalArray							(blue muchDarker)			bold)
	(string									(magenta muchDarker)	normal)
	(unfinishedString						red			normal		)
	(assignment								nil			bold			)
	(ansiAssignment 						nil			bold)
	(literal									nil			italic)
	(keyword								(blue muchDarker)			)
	(binary 								(blue muchDarker)			)	
	(unary									(blue muchDarker)			)
	(incompleteKeyword						(gray muchDarker)			underlined)
	(incompleteBinary 						(gray muchDarker)			underlined)	
	(incompleteUnary						(gray muchDarker)			underlined)
	(undefinedKeyword						red			)
	(undefinedBinary 						red			)	
	(undefinedUnary						red			)													
	(patternKeyword 						nil			bold)
	(patternBinary 							nil			bold)
	(patternUnary							nil			bold)	
	(#self 									(red muchDarker)	bold)
	(#super									(red muchDarker)	bold) 
	(#true 									(red muchDarker)	bold)
	(#false 									(red muchDarker)	bold)
	(#nil 									(red muchDarker)	bold)
	(#thisContext 							(red muchDarker)	bold)
	(#return								(red muchDarker)	bold)
	(patternArg 							(blue muchDarker)			italic)	
	(methodArg 								(blue muchDarker)			italic)
	(blockPatternArg 						(blue muchDarker)			italic)
	(blockArg 								(blue muchDarker)			italic)
	(argument 								(blue muchDarker)			italic)
	(blockArgColon							black		) 
	(leftParenthesis							black		) 
	(rightParenthesis						black		) 
	(leftParenthesis1						(green muchDarker)		) 
	(rightParenthesis1						(green muchDarker)		) 
	(leftParenthesis2						(magenta muchDarker)		) 
	(rightParenthesis2						(magenta muchDarker)		) 
	(leftParenthesis3						(red muchDarker)		) 
	(rightParenthesis3						(red muchDarker)		) 
	(leftParenthesis4						(green darker)		) 
	(rightParenthesis4						(green darker)		) 
	(leftParenthesis5						(orange darker)		) 
	(rightParenthesis5						(orange darker)		) 
	(leftParenthesis6						(magenta darker)		) 
	(rightParenthesis6						(magenta darker)		) 
	(leftParenthesis7						blue		) 
	(rightParenthesis7						blue		) 
	(blockStart 								black		) 
	(blockEnd 								black		) 
	(blockStart1								(green muchDarker)			) 
	(blockEnd1								(green muchDarker)			) 
	(blockStart2								(magenta muchDarker)		) 
	(blockEnd2								(magenta muchDarker)		) 
	(blockStart3								(red muchDarker)		) 
	(blockEnd3								(red muchDarker)		) 
	(blockStart4								(green darker)		) 
	(blockEnd4								(green darker)		) 
	(blockStart5								(orange darker)		) 
	(blockEnd5								(orange darker)		) 
	(blockStart6								(magenta darker)		) 
	(blockEnd6								(magenta darker)		) 
	(blockStart7								blue		) 
	(blockEnd7								blue		) 																																																		
	(arrayStart								black		) 
	(arrayEnd								black		) 
	(arrayStart1							black		) 
	(arrayEnd1								black		) 
	(byteArrayStart								black		) 
	(byteArrayEnd								black		) 
	(byteArrayStart1							black		) 
	(byteArrayEnd1								black		) 
	(leftBrace 								black		) 
	(rightBrace 								black		) 
	(cascadeSeparator 						black		) 
	(statementSeparator 						black		) 
	(externalCallType 						black		) 
	(externalCallTypePointerIndicator 		black		) 
	(primitiveOrExternalCallStart 			black	bold	) 
	(primitiveOrExternalCallEnd				black	bold	)
	(methodTempBar							gray		) 
	(blockTempBar 							gray		)
	(blockArgsBar							gray		)
	(primitive								(green muchDarker)		bold)
	(pragmaKeyword						(green muchDarker)		bold)
	(pragmaUnary							(green muchDarker)		bold)
	(pragmaBinary							(green muchDarker)		bold)									
	(externalFunctionCallingConvention		(green muchDarker)		bold) 
	(module									(green muchDarker)		bold)
	(blockTempVar 							gray		italic)
	(blockPatternTempVar					gray		italic)
	(instVar 								black		bold)
	(workspaceVar							black		bold)
	(undefinedIdentifier						red			bold)
	(incompleteIdentifier					(gray darker) 	(italic underlined))
	(tempVar								(gray darker)	italic)
	(patternTempVar						(gray darker)	italic)
	(poolConstant							(gray darker)	italic)
	(classVar								(gray darker)	bold)
	(globalVar								black		bold) )
							! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'nice 12/27/2009 03:12'!
initialTextAttributesForPixelHeight: aNumber
	| d |
	 
	d := IdentityDictionary new.
	self styleTable do: [:each | | textStyle element emphasis font pixelHeight attrArray color textStyleName |
		element := each first.
		color := each at: 2 ifAbsent:[nil].
		color:=color ifNotNil: [Color colorFrom: color].
		emphasis := each at: 3 ifAbsent:[nil].
		textStyleName := each at: 4 ifAbsent: [nil].
		pixelHeight := each at: 5 ifAbsent: [aNumber].	
		textStyleName ifNil:[pixelHeight := nil].	
		textStyle := TextStyle named: textStyleName.
		font := textStyle ifNotNil:[pixelHeight ifNotNil:[textStyle fontOfSize: pixelHeight]].
		attrArray := self attributeArrayForColor: color emphasis: emphasis font: font.
		attrArray notEmpty 
			ifTrue:[
				d at: element put: attrArray]].
	^d	
	! !

!SHTextStylerST80 class methodsFor: 'class initialization' stamp: 'fbs 11/23/2013 16:17'!
initialize  
	"Clear styleTable and textAttributesByPixelSize cache so that they will 
	reinitialize.	 

		SHTextStylerST80 initialize
	" 
	
	styleTable := nil.
	textAttributesByPixelHeight := nil.	! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'fbs 11/23/2013 16:16'!
leftArrowAssignmentPreferenceChanged
	"the user has changed the syntaxHighlightingAsYouTypeLeftArrowAssignment setting.
	If they have turned it on then force syntaxHighlightingAsYouTypeAnsiAssignment
	to be turned off"
	self syntaxHighlightingAsYouTypeLeftArrowAssignment 
		ifTrue: [self syntaxHighlightingAsYouTypeAnsiAssignment: false]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'ul 10/3/2010 01:16'!
styleTable

	^styleTable ifNil: [ styleTable := self chooseDefaultStyleTable ]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'tween 8/28/2004 16:28'!
styleTable: anArray
	"Set the receiver's styleTable to anArray.
	Clear textAttributesByPixelSize cache so that it will reinitialize.	 
	" 
	
	styleTable := anArray.
	textAttributesByPixelHeight := nil! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'ul 1/28/2011 01:00'!
subduedStyleTable
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
^#(
	"(symbol	color		[emphasisSymbolOrArray		[textStyleName [pixelHeight]]])"		
	(default 								black 		)
	(invalid 								red 			)
	(excessCode 								red 			)
	(comment 								(cyan muchDarker) 		)
	(unfinishedComment 					(red muchDarker) 	italic)
	(#'$'									(red muchDarker) 	)
	(character								(red muchDarker) 	)
	(integer									(red muchDarker) 	)
	(number								(red muchDarker) 	)	
	(#-										(red muchDarker) 	)
	(symbol									(blue muchDarker)			)	
	(stringSymbol							(blue muchDarker)			)	
	(literalArray							(blue muchDarker)			)
	(string									(magenta muchDarker)	normal			)
	(unfinishedString						red			normal			)
	(assignment								nil			bold			)
	(ansiAssignment 						nil			bold)
	(literal									nil			italic)
	(keyword								(blue muchDarker)			)
	(binary 								(blue muchDarker)			)	
	(unary									(blue muchDarker)			)
	(incompleteKeyword						(gray muchDarker)			underlined)
	(incompleteBinary 						(gray muchDarker)			underlined)	
	(incompleteUnary						(gray muchDarker)			underlined)
	(undefinedKeyword						red			)
	(undefinedBinary 						red			)	
	(undefinedUnary						red			)													
	(patternKeyword 						nil			bold)
	(patternBinary 							nil			bold)
	(patternUnary							nil			bold)	
	(#self 									(red muchDarker)	)
	(#super									(red muchDarker)	) 
	(#true 									(red muchDarker)	)
	(#false 									(red muchDarker)	)
	(#nil 									(red muchDarker)	)
	(#thisContext 							(red muchDarker)	)
	(#return								(red muchDarker)	)
	(patternArg 							(blue muchDarker)			)	
	(methodArg 								(blue muchDarker)			)
	(blockPatternArg 						(blue muchDarker)			)
	(blockArg 								(blue muchDarker)			)
	(argument 								(blue muchDarker)			)
	(blockArgColon							black		) 
	(leftParenthesis							black		) 
	(rightParenthesis						black		) 
	(leftParenthesis1						(green muchDarker)		) 
	(rightParenthesis1						(green muchDarker)		) 
	(leftParenthesis2						(magenta muchDarker)		) 
	(rightParenthesis2						(magenta muchDarker)		) 
	(leftParenthesis3						(red muchDarker)		) 
	(rightParenthesis3						(red muchDarker)		) 
	(leftParenthesis4						(green darker)		) 
	(rightParenthesis4						(green darker)		) 
	(leftParenthesis5						(orange darker)		) 
	(rightParenthesis5						(orange darker)		) 
	(leftParenthesis6						(magenta darker)		) 
	(rightParenthesis6						(magenta darker)		) 
	(leftParenthesis7						blue		) 
	(rightParenthesis7						blue		) 
	(blockStart 								black		) 
	(blockEnd 								black		) 
	(blockStart1								(green muchDarker)			) 
	(blockEnd1								(green muchDarker)			) 
	(blockStart2								(magenta muchDarker)		) 
	(blockEnd2								(magenta muchDarker)		) 
	(blockStart3								(red muchDarker)		) 
	(blockEnd3								(red muchDarker)		) 
	(blockStart4								(green darker)		) 
	(blockEnd4								(green darker)		) 
	(blockStart5								(orange darker)		) 
	(blockEnd5								(orange darker)		) 
	(blockStart6								(magenta darker)		) 
	(blockEnd6								(magenta darker)		) 
	(blockStart7								blue		) 
	(blockEnd7								blue		) 																																																		
	(arrayStart								black		) 
	(arrayEnd								black		) 
	(arrayStart1							black		) 
	(arrayEnd1								black		) 
	(byteArrayStart								black		) 
	(byteArrayEnd								black		) 
	(byteArrayStart1							black		) 
	(byteArrayEnd1								black		) 
	(leftBrace 								black		) 
	(rightBrace 								black		) 
	(cascadeSeparator 						black		) 
	(statementSeparator 						black		) 
	(externalCallType 						black		) 
	(externalCallTypePointerIndicator 		black		) 
	(primitiveOrExternalCallStart 			black		) 
	(primitiveOrExternalCallEnd				black		)
	(methodTempBar							gray		) 
	(blockTempBar 							gray		)
	(blockArgsBar							gray		)
	(primitive								(green muchDarker)		bold)
	(pragmaKeyword						(green muchDarker)		bold)
	(pragmaUnary							(green muchDarker)		bold)
	(pragmaBinary							(green muchDarker)		bold)									
	(externalFunctionCallingConvention		(green muchDarker)		bold) 
	(module									(green muchDarker)		bold)
	(blockTempVar 							gray		)
	(blockPatternTempVar					gray		)
	(instVar 								black		)
	(workspaceVar							black		)
	(undefinedIdentifier						red			)
	(incompleteIdentifier					(gray darker) 	(italic underlined))
	(tempVar								(gray darker)	)
	(patternTempVar						(gray darker)	)
	(poolConstant							(gray muchDarker)	)
	(classVar								(gray muchDarker)	)
	(globalVar								black		) )! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'ar 8/21/2009 21:45'!
subduedSyntaxHighlights
	<preference: 'Subdued Syntax Highlighting'
		category: 'browsing'
		description: 'When enabled, use a more subdued syntax highlighting approach that is not as aggressive in the face newbies. Intended to introduce people gracefully to the shiny colorful world of Squeak syntax'
		type: #Boolean>
	^SubduedSyntaxHighlights ifNil:[true]! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'ar 8/21/2009 21:50'!
subduedSyntaxHighlights: aBool
	"Change the subdued syntax highlighting preference"
	SubduedSyntaxHighlights := aBool.
	"Force reload"
	styleTable := nil.
	textAttributesByPixelHeight := nil.! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'kfr 1/6/2016 20:26'!
syntaxHighlighting
	<preference: 'syntaxHighlighting'
		category: 'browsing'
		description: 'Enable, or disable, Shout - Syntax Highlighting. When enabled, code in Browsers and Workspaces is styled to reveal its syntactic structure.'
		type: #Boolean>
	^SyntaxHighlighting ifNil: [true]! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'kfr 1/6/2016 20:27'!
syntaxHighlighting: aBoolean
	SyntaxHighlighting := aBoolean.! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'fbs 11/23/2013 15:26'!
syntaxHighlightingAsYouType
	<preference: 'syntaxHighlightingAsYouType'
		category: 'browsing'
		description: 'Enable, or disable, Shout - Syntax Highlighting As You Type. When enabled, code in Browsers and Workspaces is styled to reveal its syntactic structure. When the code is changed (by typing some characters, for example), the styling is changed so that it remains in sync with the modified code.'
		type: #Boolean>
	^SyntaxHighlightingAsYouType ifNil: [true]! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'fbs 11/23/2013 15:27'!
syntaxHighlightingAsYouType: aBoolean
	SyntaxHighlightingAsYouType := aBoolean.! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'ul 7/3/2015 23:32'!
syntaxHighlightingAsYouTypeAnsiAssignment
	<preference: 'syntaxHighlightingAsYouTypeAnsiAssignment'
		category: 'browsing'
		description: 'If true, and syntaxHighlightingAsYouType is enabled,  all left arrow assignments ( _ ) will be converted to the ANSI format ( := ) when a method is selected in a Browser. Whilst editing a method, this setting has no effect - both the left arrow and the ansi format may be used.'
		type: #Boolean>
	^SyntaxHighlightingAsYouTypeAnsiAssignment ifNil: [true]! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'fbs 11/23/2013 15:19'!
syntaxHighlightingAsYouTypeAnsiAssignment: aBoolean
	SyntaxHighlightingAsYouTypeAnsiAssignment := aBoolean.! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'fbs 11/23/2013 15:24'!
syntaxHighlightingAsYouTypeLeftArrowAssignment
	<preference: 'syntaxHighlightingAsYouTypeLeftArrowAssignment'
		category: 'browsing'
		description: 'If true, and syntaxHighlightingAsYouType is enabled,  all ANSI format assignments ( := ) will be converted to left arrows ( _ ) when a method is selected in a Browser. Whilst editing a method, this setting has no effect - both the left arrow and the ansi format may be used.'
		type: #Boolean>
	^SyntaxHighlightingAsYouTypeLeftArrowAssignment ifNil: [true]! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'fbs 11/23/2013 15:01'!
syntaxHighlightingAsYouTypeLeftArrowAssignment: aBoolean
	SyntaxHighlightingAsYouTypeLeftArrowAssignment := aBoolean.! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'lr 12/18/2009 11:30'!
textAttributesByPixelHeight
	^ textAttributesByPixelHeight ifNil: [ textAttributesByPixelHeight := Dictionary new ]! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'ul 7/27/2014 07:28'!
attributesFor: aSymbol

	^(attributesByPixelHeight ifNil: [
		attributesByPixelHeight := self class attributesByPixelHeight: self pixelHeight ])
		at: aSymbol
		ifAbsent: nil! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: 'tween 4/9/2004 12:47'!
classOrMetaClass: aBehavior
	classOrMetaClass := aBehavior! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'tween 4/28/2004 10:44'!
convertAssignmentsToAnsi: aText
	"If the Preference is to show ansiAssignments then answer a copy of  <aText> where each  left arrow assignment is replaced with a ':=' ansi assignment. A parser is used so that each left arrow is only replaced if it occurs within an assigment statement"

	^self replaceStringForRangesWithType: #assignment with: ':=' in: aText! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'tween 4/28/2004 10:45'!
convertAssignmentsToLeftArrow: aText
	"If the Preference is to show leftArrowAssignments then answer a copy of  <aText> where each ansi assignment (:=) is replaced with a left arrow. A parser is used so that each ':=' is only replaced if it actually occurs within an assigment statement"

	^self replaceStringForRangesWithType: #ansiAssignment with: '_' in: aText! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: 'tween 5/9/2004 12:50'!
environment: anObject
	environment := anObject! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: 'tween 4/18/2004 10:32'!
font: aFont
	font := aFont! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: 'tween 5/1/2004 14:33'!
formatAssignments: aBoolean
	"determines whether assignments are reformatted according to the Preferences,
	or left as they are"
	formatAssignments := aBoolean! !

!SHTextStylerST80 methodsFor: 'initialize-release' stamp: 'tween 8/28/2004 00:20'!
initialize
	super initialize.
	formatAssignments := true! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: 'ul 5/5/2015 00:57'!
parseAMethod: aBoolean

	parseAMethod := aBoolean! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'tween 8/26/2004 02:55'!
parseableSourceCodeTemplate

	^'messageSelectorAndArgumentNames
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'tween 2/17/2007 12:47'!
pixelHeight
	"In Morphic the receiver will have been given a code font, in MVC the font will be nil. So when the font is nil, answer the pixelHeight of the MVC Browsers' code font, i.e. TextStyle defaultFont pixelHeight"
	^pixelHeight 
		ifNil:[pixelHeight := (font 
				ifNil:[TextStyle defaultFont]) pixelSize]! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'fbs 11/23/2013 16:11'!
privateFormat: aText
	"Perform any formatting of aText necessary and answer either aText, or a formatted copy of aText"

	aText asString = Object sourceCodeTemplate
		ifTrue:[
			"the original source code template does not parse,
			replace it with one that does"
			^self parseableSourceCodeTemplate asText].
	formatAssignments
		ifTrue:[
			self class syntaxHighlightingAsYouTypeAnsiAssignment 
				ifTrue:[^self convertAssignmentsToAnsi: aText].
			self class syntaxHighlightingAsYouTypeLeftArrowAssignment 
				ifTrue:[^self convertAssignmentsToLeftArrow: aText]].		
	^aText! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'tween 8/26/2004 03:14'!
privateStyle: aText

	| ranges |
	ranges := self rangesIn: aText setWorkspace: true.
	ranges ifNotNil: [self setAttributesIn: aText fromRanges: ranges]! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'ul 5/5/2015 00:58'!
rangesIn: aText setWorkspace: aBoolean
	"Answer a collection of SHRanges by parsing aText.
	When formatting it is not necessary to set the workspace, and this can make the parse take less time, so aBoolean specifies whether the parser should be given the workspace"

	| shoutParserClass |
	"Switch parsers if we have to"
	shoutParserClass := (classOrMetaClass ifNil:[Object]) shoutParserClass.
	parser class == shoutParserClass ifFalse:[parser := shoutParserClass new].
	parser parseAMethod: parseAMethod.
	^parser 
		rangesIn: aText asString 
		classOrMetaClass: classOrMetaClass 
		workspace: (aBoolean ifTrue:[workspace])  
		environment: environment
! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'nice 12/27/2009 03:12'!
replaceStringForRangesWithType: aSymbol with: aString in: aText 
	"Answer aText if no replacements, or a copy of aText with 
	each range with a type of aSymbol replaced by aString"
	| answer toReplace adjustSourceMap increaseInLength |
	
	toReplace := (self rangesIn: aText setWorkspace: false) 
		select: [:each | each type = aSymbol].
	toReplace isEmpty ifTrue: [^aText].
	answer := aText copy.
	increaseInLength := 0.
	adjustSourceMap := sourceMap notNil and:[sourceMap ~~ processedSourceMap].
	(toReplace asSortedCollection: [:a :b | a start <= b start]) 
		do: [:each | | end start thisIncrease | 
			start := each start + increaseInLength.
			end := each end + increaseInLength.
			answer 	replaceFrom: start to: end with: aString.
			thisIncrease := aString size - each length.
			increaseInLength := increaseInLength + thisIncrease.
			adjustSourceMap ifTrue:[
				sourceMap do:[:assoc | | first newFirst last newLast |
					first := newFirst := assoc value first.
					last := newLast := assoc value last.
					first > start ifTrue:[newFirst := first + thisIncrease].
					last > start ifTrue:[newLast := last + thisIncrease].
					(first ~= newFirst or:[last ~= newLast])
						ifTrue:[assoc value: (newFirst to: newLast)]]]].
	adjustSourceMap ifTrue:[processedSourceMap := sourceMap]. 
	^answer! !

!SHTextStylerST80 methodsFor: 'private' stamp: 'ul 5/18/2015 03:40'!
setAttributesIn: aText fromRanges: ranges

	| defaultAttributes newRuns newValues lastAttributes oldRuns nextIndex lastCount | 		
	oldRuns := aText runs.
	defaultAttributes := self attributesFor: #default.
	newRuns := OrderedCollection new: ranges size * 2 + 1.
	newValues := OrderedCollection new: ranges size * 2 + 1.
	lastAttributes := nil.
	nextIndex := 1.
	lastCount := 0.
	ranges do: [ :range |
		| attributes |
		nextIndex < range start ifTrue: [ 
			lastAttributes == defaultAttributes 
				ifTrue: [
					lastCount := lastCount + range start - nextIndex.
					newRuns at: newRuns size put: lastCount ]
				ifFalse: [
					lastCount := range start - nextIndex.
					newRuns addLast: lastCount. 
					lastAttributes := defaultAttributes.
					newValues addLast: lastAttributes ].
			nextIndex := range start ].
		attributes := (self attributesFor: range type) ifNil: [ defaultAttributes ].
		lastAttributes == attributes
			ifTrue: [ 
				lastCount := lastCount + range end - nextIndex + 1.
				newRuns at: newRuns size put: lastCount ]
			ifFalse: [
				lastCount := range end - nextIndex + 1.
				newRuns addLast: lastCount.
				lastAttributes := attributes.
				newValues addLast: lastAttributes ].
		nextIndex := range end + 1 ].
	nextIndex <= aText size ifTrue: [
		lastAttributes == defaultAttributes 
				ifTrue: [
					lastCount := lastCount + aText size - nextIndex + 1.
					newRuns at: newRuns size put: lastCount ]
				ifFalse: [
					lastCount := aText size - nextIndex + 1.
					newRuns addLast: lastCount.
					lastAttributes := defaultAttributes.
					newValues addLast: lastAttributes ] ].
	aText runs: (RunArray runs: newRuns values: newValues).
	oldRuns withStartStopAndValueDo: [ :start :stop :attribs |
		(attribs anySatisfy: [ :each | each shoutShouldPreserve ]) ifTrue: [
			attribs do: [ :each | aText addAttribute: each from: start to: stop ] ] ].
	! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: 'tween 8/9/2005 15:37'!
sourceMap: aSortedCollection
	"set the receiver's sourceMap to aSortedCollection.
	The sourceMap is used by a Debugger to select the appropriate
	ranges within its text. These ranges need to be adjusted if, and when, the receiver
	reformats the text that is displayed"

	sourceMap := aSortedCollection! !

!SHTextStylerST80 methodsFor: 'converting' stamp: 'nice 5/8/2011 12:07'!
unstyledTextFrom: aText
	"Re-implemented so that TextActions are not removed from aText"
	| answer |	
	answer := super unstyledTextFrom: aText.
	aText runs withStartStopAndValueDo: [:start :stop :attribs |
		(attribs anySatisfy: [:each | each isKindOf: TextAction])
			ifTrue: [
				attribs do: [:eachAttrib | answer addAttribute: eachAttrib from: start to: stop]]].
	^answer! !

!SHTextStylerST80 methodsFor: 'copying' stamp: 'cmm 4/26/2011 14:29'!
veryDeepInner: aDeepCopier 
	super veryDeepInner: aDeepCopier.
	classOrMetaClass := classOrMetaClass veryDeepCopyWith: aDeepCopier.
	workspace := workspace veryDeepCopyWith: aDeepCopier.
	"share the font?"
	parser := parser veryDeepCopyWith: aDeepCopier.
	sourceMap := sourceMap veryDeepCopyWith: aDeepCopier.
	processedSourceMap := processedSourceMap veryDeepCopyWith: aDeepCopier! !

!SHTextStylerST80 methodsFor: 'accessing' stamp: 'tween 4/15/2004 13:23'!
workspace: aWorkspace
	workspace := aWorkspace! !

!Dictionary methodsFor: '*ShoutCore' stamp: 'tween 9/13/2004 10:11'!
hasBindingThatBeginsWith: aString
	"Answer true if the receiver has a key that begins with aString, false otherwise"
	
	self keysDo:[:each | 
		(each beginsWith: aString)
			ifTrue:[^true]].
	^false! !

!Model methodsFor: '*ShoutCore' stamp: 'mt 5/6/2015 09:30'!
hasBindingThatBeginsWith: aString

	^ false! !

!MCSnapshotBrowser methodsFor: '*ShoutCore' stamp: 'kb 2/26/2010 14:59'!
hasBindingThatBeginsWith: aString

	^false! !

!Environment methodsFor: '*ShoutCore' stamp: 'cwp 1/1/2014 12:57'!
hasBindingThatBeginsWith: aString
	bindings associationsDo:
		[:ea | (ea key beginsWith: aString) ifTrue: [^ true]].
	^ false
	
! !

!PseudoClass methodsFor: '*ShoutCore' stamp: 'ul 7/26/2015 22:43'!
shoutParserClass

	^SHParserST80
! !

!TextAction methodsFor: '*ShoutCore' stamp: 'ul 5/2/2015 13:40'!
shoutShouldPreserve

	^true! !

!SystemDictionary methodsFor: '*ShoutCore' stamp: 'ul 11/17/2010 05:20'!
hasBindingThatBeginsWith: aString
	"Use the cached class and non-class names for better performance."

	| name searchBlock |
	searchBlock := [ :element |
		(element beginsWith: aString)
			ifTrue: [ 0 ]
			ifFalse: [
				aString < element
					ifTrue: [ -1 ]
					ifFalse: [ 1 ] ] ].
	name := self classNames 
		findBinary: searchBlock
		ifNone: [ nil ].
	name ifNotNil: [ ^true ].
	name := self nonClassNames 
		findBinary: searchBlock
		ifNone: [ nil ].
	^name notNil! !

!Workspace methodsFor: '*ShoutCore' stamp: 'kb 2/22/2010 22:18'!
hasBindingThatBeginsWith: aString 
	
	bindings ifNil: [ ^false ].
	bindings keysDo: [ :each |
		(each beginsWith: aString) ifTrue: [ ^true ] ].
	^false! !

!Behavior methodsFor: '*ShoutCore-Parsing' stamp: 'ar 2/19/2010 17:02'!
shoutParserClass
	"Answer the parser class"
	^SHParserST80! !

!SmalltalkImage methodsFor: '*ShoutCore' stamp: 'ul 9/19/2010 22:19'!
hasBindingThatBeginsWith: aString
	"Answer true if the receiver has a key that begins with aString, false otherwise"
	
	^globals hasBindingThatBeginsWith: aString! !

!TextAttribute methodsFor: '*ShoutCore' stamp: 'ul 7/26/2014 07:13'!
shoutShouldPreserve

	^false! !

!SharedPool class methodsFor: '*ShoutCore' stamp: 'tween 9/13/2004 10:10'!
hasBindingThatBeginsWith: aString
	"Answer true if the receiver has a binding that begins with aString, false otherwise"

	"First look in classVar dictionary."
	(self classPool hasBindingThatBeginsWith: aString) ifTrue:[^true].
	"Next look in shared pools."
	self sharedPools do:[:pool | 
		(pool hasBindingThatBeginsWith: aString) ifTrue: [^true]].
	^false! !
SHTextStylerST80 initialize!
